_driver(`
dnl taxi source file for the null driver
dnl ---------------------------------------------------------
dnl      preamble
dnl ---------------------------------------------------------
_addAuthor(`Tom Heydt-Benjamin')
_addAuthor(`John Rodriguez')
_version(`0.0')
_description(`Null driver with debugging output')
_license(`GPL')

_name(`testNull')

_major(`244')
_minor(`0')
dnl ---------------------------------------------------------
dnl      body
dnl ---------------------------------------------------------

_lseek(`
dnl
  _return(_FilePosition = 0)
')

_read(`
  _kernelPrint("_DriverName: read()\n")
  _return(_Success)
')

_write(`
  int i;
  char *kernelSpaceBuffer;
  _mallocDefine(NULL_BUFFER, "nullbuffer", "buffer for testNull module")
  kernelSpaceBuffer = _malloc(_InputLength, NULL_BUFFER, _WAITOK);

  if (!kernelSpaceBuffer) _return(_ENOMEM)

  _copyin(_InputBase, kernelSpaceBuffer, _InputLength)
  if (_TaxiRetval) { /* handle any error that copyin returns */
    _free(kernelSpaceBuffer);
    return _TaxiRetval;
  }

  for (i = 0; i < _InputLength; i++) {
    _kernelPrint(`"_DriverName: writing: %c\n", kernelSpaceBuffer[i]')
  }
  _free(kernelSpaceBuffer, NULL_BUFFER);
  _setWriteBytesWritten(i)
')

_open(`
  _markModuleUsage()
  _kernelPrint("_DriverName: open()\n")
  _return(_Success)
')

_release(`
  _unmarkModuleUsage()
  _kernelPrint("_DriverName: release()\n")
  _return(_Success)
')

_load(`
  _kernelPrint("_DriverName: init()\n")
dnl /* _registerModule() returns success or failure into _TaxiRetval */
  _registerModule()
  _return(_TaxiRetval)
')

_unload(`
  _kernelPrint("_DriverName: exit()\n")
  _unregisterModule()
')

')dnl # end _driver()
